# Atrus firmware changelog

## 1.0.1 (2017-10-03)

### New features and improvements
* New mic selection algorithm
* New mic AGC algorithm
* Less noise artifacts during double talk
* Changed volume steps to have higher default volume in bluestreak rooms
* Latency is improved by 4 ms
* Send a reboot command to host if hook on is pressed for 9 seconds

### Bug fixes
* Removed a generated sound on hook on

### Known issues
* Pop sound when power is hotplugged.


## 1.0.0 (2017-08-27)

### New features and improvements
* Added preamble to daisy-commands for robustness to disturbances.
* Added diagnostic command for daisy chain power.
* Sends full version string as diagnostics, not just bcd.
* Improvements of AGC for microphones.

### Bug fixes
* Only enables full speed USB during init.
* Fixes issue with daisy chain sync.

### Known issues
* Pop sound when power is hotplugged.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.


## 0.8.2 (2017-08-03)

### New features and improvements
* Added diagnostics command to check if Atrus only receives silent audio packages.
* Added diagnostics command to check if the host have enabled Atrus loudspeaker and microphone.

### Bug fixes
* Fixed issue with volume sync with CfM

### Known issues
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.


## 0.8.1 (2017-07-23)

### Bug fixes
* Fixed critical issue with Atrus sometimes sending hook on command when the user presses volume up, down and mute.

### Known issues
* Volume sync with CfM does not work.
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.


## 0.8.0 (2017-07-06)

### New features and improvements
* Added HID command to check for voice activity when muted.
* Latency improvements in TrueVoice.
* Added TrueVoice diagnostics.

### Changes
* Change of volume range, the 5 lowest steps removed.

### Bug fixes
* Fixed issue with daisy chain device not being detected when hot-plugged.
* Fixed issue with device beeping if either CPU halts.
* Fixed issue with device connected to host ending up in idle state.

### Known issues
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync a fter boot.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.


## 0.7.2 (2017-06-26)

### Bug fixes
* Fix timing in ADC driver to resolve issue with distortion on microphones.

### Known issues
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.7.1 (2017-06-19)

### New features and improvements
* Improved latency in TrueVoice
* Improved dist estimation

### Known issues
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.7.0 (2017-06-07)

### New features and improvements
* Improved latency
* ChromeOS volume sync in CfM
* Cleanup of HID report
* New diagnostics commands
* Enable support for loop through of high frequencies
* TrueVoice wideband improvements
* TrueVoice noise estimation improvements
* TrueVoice dist estimation improvements

### Changes
* LED intensity set based on HWID

### Bug fixes
* Disconnect and reconnect USB if device is idle to long to make sure connection with host is not lost

### Known issues
* Pop sound when power is hotplugged.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.8 (2017-05-10)

### Changes
* Roll back fix to remove click noise when device is powering down, fix is causing issues with amplifier on some HW.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.7 (2017-04-07)

### New features and improvements
* Faster boot time.
* Faster diagnostics response time from DSP.
* Added hang-detection in the USB task.

### Bug fixes
* Remove click noise when USB is disconnected.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.6 (2017-03-16)

### Changes
* Disable RF protection in the touch controllers.

### Bug fixes
* Fixed issue with getting the wrong HWID from FPGA.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.5 (2017-03-10)

### New features and improvements
* Implement watchdog to reset the system if the system hangs for more than 2 seconds.
* Added new diagnostics commands.

### Bug fixes
* Fixed issue with SPI transfer during single unit DFU.
* Fixed issue with HID synchronization.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.4 (2017-02-21)

### New features and improvements
* Noise level stability during unit to unit call during bad ERLE or echo path change, including fix for howling tendencies.
* Problems with half duplex on frequencies above 8 kHz have been fixed.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.3 (2017-02-20)

### Changes
* VID/PID for USB updated. VID: 0x18D1, PID: 0x8001 in runtime, and 0x8002 in DFU mode.

### New features and improvements
* Improved functionality to handle DFU errors via USB.
* Host can request a check that the SHARC is alive and up and running via HID.
* Host can request a dump of the states of mute, hook on/off, volume, LEDs via HID.
* Host can request status of the analog calibration of the touch controllers via HID.
* Device will respond that a command is unavailable if the host tries to use a non existing command.

### Bug fixes
* Fixed issue with disconnecting/connecting USB several times in a row may cause the device to crash.
* Fix issue with hid-queries during distribution of upgrades being lost
* Fix handling of multiple pending HID-queries

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.


## 0.6.2 (2017-01-27)

### New features and improvements
* Host can request status of daisy chain DFU from the master via HID
* Host can request mininmum version of connected slaves via HID
* Host can request number of slaves connected to the master via HID
* Host can request uptime for the master via HID

### Bug fixes
* Send HID commands on all button presses
* Fix issue with lost HID reports
* Fix issue with lost SPI commands
* Fixed issue with unresponsive buttons in standby mode (yellow LEDs).

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected, the slave unit then stays in standby-mode until reboot.
* DFU error via USB not implemented
* Disconnecting/connecting USB several times in a row may cause the device to crash


## 0.6.1 (2016-12-21)

### New features and improvements
* UI sounds updated
* HID support for diagnostics
* Host can request firmware version of slaves connected to the master via HID
* Host can request serial number of slaves connected to the master via HID

### Bug fixes
* Button presses are ignored during daisy chain DFU
* Removed first start up sound. There were 2 sounds played before, one for start up and one for USB host detection.

### Known issues
* If the last unit in the chain is unplugged while the system is running the next to last unit sometimes swithces to idle mode.
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* DFU error via USB not implemented
* Repeated use of hook on/off has caused wrong LED state
* Disconnecting/connecting USB several times in a row may cause the device to crash


## 0.6.0 (2016-010-14)

### New features and improvements
* New bootloader that checks new firmware after DFU and rolls back to previous version if it does not boot correctly.
* Atrustool updated with the new bootloader
* Added watch dog functionality during DFU, this will decrease the risk of the device hanging during DFU.
* Added watch dog during start up, the watch dog will restart the device if it fails initializing properly and hangs during the first 5 seconds.

### Bug fixes
* If USB cable is disconnected during slave DFU, the DFU process are not aborted.
* Delay start of slave DFU, to make sure all slaves have booted up properly.

### Known issues
* CFM sync, if device is disconnected and reconnected during a muted active call status does not sync after boot.
* Bootloader takes long time to boot application (indicated by green leds during boot)
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* DFU error via USB not implemented
* Repeated use of hook on/off has caused wrong LED state
* Disconnecting/connecting USB several times in a row may cause the device to crash


## 0.5.4 (2016-09-20)

### Bug fixes
* Fixed bug causing HID transfer to fail when muting/unmuting

### Known issues
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* DFU error via USB not implemented
* Repeated use of hook on/off has caused wrong LED state
* Disconnecting/connecting USB several times in a row may cause the device to crash


## 0.5.3 (2016-08-26)

### New features and improvements
* Remove the need for a SDRAM connected to the SHARC
* Master unit selection, now any device can be selected as master device
* Starup sound when connecting new units in daisy chain

### Bug fixes
* Noise when hotplugging USB
* Distorted startup sound
* Volume level change problem when plugging in a slave
* Mute status sync problem with CFM
* Not possible to join a call on CFM by pressing off hook
* Can sometimes hear high frequency tones during double talk or high provocation on near end on TX

### Changes
* Reboot if USB cable is disconnected during DFU

### Known issues
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* DFU error via USB not implemented
* Repeated use of hook on/off has caused wrong LED state
* Disconnecting/connecting USB several times in a row may cause the device to crash


## 0.5.2 (2016-07-07)

### New features and improvements
* DFU time reduced by increasing block-size over daisy-chain
* Improved daisy-chain hotplug noise

### Bug fixes
* Fix issue where mute or volume HID-commands may be ignored
* [b/29024515](http://b/29024515) lsusb on some Linux computers takes a long time to enumerate device (~1 min)
* Startup sound often sounds distorted (no longer reproducable, no change)
* LEDs are not in sync on a daisy chain setup when disconnecting and connecting usb-cable
* Mute is not syncing with hangouts (duplicate of [b/29045727](http://b/29045727))
* [b/29045727](http://b/29045727) Problem with HID mute command
* Fix locking-bug in spi flash-reading

### Changes
* Some memory-optimizations and refactoring

### Known issues
* Using wrong USB VID/PID during development
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Not possible to join a CFM call by pressing off hook on Atrus
* Volume changes to maximum volume when connecting slave units
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Connecting a USB cable to a unit other than the unit with external power will not work.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* Can sometimes hear high frequency tones during double talk or high provocation on near end on TX
* DFU error via USB not implemented
* Repeated use of hook on/off has caused wrong LED state
* USB hotplug noise


## 0.5.1 (2016-06-20)

### New features and improvements
* DFU time required for slave DFU is lowered from about 150 seconds down to about 90 seconds
* Improved daisy-chain hotplug noise
* Master does not restart a failed daisy-dfu before the slaves realise it have failed

### Bug fixes
* LEDs out of sync problem when hotplugging devices
* Robot sound after unplugging slave
* Daisy-DFU occassonally never finnish

### Changes
* Device will reboot if CRC fails during daisy chain DFU
* Changed priorities between threads in the TI DSP

### Known issues
* Using wrong USB VID/PID during development
* Startup sound often sounds distorted
* [b/29040265](http://b/29040265) The volume is not always in sync with the chromebox directly after startup
* LEDs are not in sync on a daisy chain setup when disconnecting and connecting usb-cable
* Pressing buttons while in standby (yellow), will only give a pulse on the leds when pressing + and -. It should be a pulse on all buttons.
* Not possible to join a CFM call by pressing off hook on Atrus
* Volume changes to maximum volume when connecting slave units
* Pressing on hook while in mute + online call, makes two state transitions, generating two sounds.
* Mute to idle sound different compared to mute to online
* During single A-talk the audio sometimes gets damped without any apparent cause.
* Connecting a USB cable to a unit other than the unit with external power will not work.
* Sometimes a slave unit is not recognized to be connected,(it has happened one time) The slave unit then stays in standby-mode until reboot.
* Can sometimes hear high frequency tones during double talk or high provocation on near end on TX
* [b/29024515](http://b/29024515) lsusb on some Linux computers takes a long time to enumerate device (~1 min)
* DFU error via USB not implemented
* Mute is not syncing with hangouts
* Repeated use of hook on/off has caused wrong LED state
* Minor daisy-chain hotplug noise
* USB hotplug noise
* [b/29045727](http://b/29045727) Problem with HID mute command
